# importiamo il testo
testo1 <- scan("~/alice.txt", what="character", sep="\n")

# traformiamo tutto il testo in minuscolo 
testo.low <- tolower(testo1)

# traformiamo il testo in vettore di parole
testo.vet <- strsplit(testo.low, "\\W")

# separiamo le parole con la funzione unlist()
unl.testo <- unlist(testo.vet)

# cancelliamo gli spazi bianchi
spazi.bianchi <-  which(unl.testo != "")
unl.testo2 <- unl.testo[spazi.bianchi]

# creiamo una tabella
freq.un <- table(unl.testo2)

# riordiniamo le parole in base alla frequenza
freq.list <- sort(freq.un, decreasing = TRUE)

# eliminiamo le stopwords e gli spazi bianchi
alice.meno.stopwords <- removeWords(unl.testo2, stopwords("english"))
spazi.bianchi2 <-  which(alice.meno.stopwords != "")
alice.meno.stopwords2 <- alice.meno.stopwords[spazi.bianchi2]

# creiamo una tabella
tab.alice <- table(alice.meno.stopwords2)

# selezioniamo le venti parole più utilizzate
mfreq.alice <- o.tab.alice[1:20]

# riordiniamo le parole in ordine decrescente
o.tab.alice <- sort(tab.alice, decreasing = TRUE)

# traduciamo l'oggetto in matrice
m.alice <- as.matrix(mfreq.alice)

# attribuiamo un nome alle colonne
colnames(m.alice) <- c("frequenza")

# calcoliamo le frequenze delle parole
rowSums(m.alice)

# creiamo una rappresentazione grafica delle dieci parole più utilizzate
barplot(m.alice[1:10], col = "blue")
