## tm

install.packages("tm")
library(tm)

getSources()

getReaders()


link <- "http://www.gutenberg.org/files/11/11-0.txt"
alice <- readLines(link, encoding = "UTF-8")

url <- "/Users/valentinaporcu/R_test/text/alice.txt"
alice <- readLines(url, encoding = "UTF-8")

# importazione con tm
alice_corvet <- VCorpus(VectorSource(alice))
inspect(alice_corvet[200:205])


getTransformations()

# preprocessing
alice4 <- tm_map(alice_corvet, tolower)

# alternativa
alice4 <- tm_map(alice_corvet, content_transformer(tolower))


alice5 <- tm_map(alice4, removePunctuation)
alice6 <- tm_map(alice5, removeNumbers)
alice7 <- tm_map(alice6, removeWords, stopwords("english"))


inspect(alice7)

stopwords("english")
stopwords("fr")
stopwords("it")

my_stop <- c("update", "lol", "rotfl")

alice7 <- tm_map(alice6, removeWords, my_stop)

alice8 <- tm_map(alice7, stripWhitespace)

alice.TDM <- TermDocumentMatrix(alice4, control = list(removePunctuation = TRUE, stopwords = TRUE, tolower = TRUE))

alice.tm <- as.matrix(alice.TDM)

alice.tf <- rowSums(alice.tm)

alice.tsort <- sort(alice.tf, decreasing = TRUE)

head(alice.tsort, 10)

barplot(alice.tsort[1:10], col = "red")