# carichiamo il dataset
tot <- read.table("/Users/valentinaporcu/R_test/smsspamcollection/SMSSpamCollection", 
                  quote = "", 
                  sep='\t',
                  row.names = NULL, 
                  stringsAsFactors = FALSE)


spam <- subset(tot, V1=="spam")
ham <- subset(tot, V1=="ham")

spam <- spam[1:300,]
ham <- ham[1:300,]

spam2 <- rbind(spam, ham)

set.seed(1234)
random <- runif(nrow(spam2))
spam3 <- spam2[order(random),]

# rinominiamo le colonne
colnames(spam3) <- c("cat", "text")

table(spam3$cat)

library(tm)

# normalizziamo l'oggetto di train
spam4 <- VCorpus(VectorSource(spam3$text))
spam4 <- tm_map(spam4,content_transformer(tolower))
spam4 <- tm_map(spam4,stripWhitespace)
spam4 <- tm_map(spam4,removePunctuation)
spam4 <- tm_map(spam4,removeNumbers)
spam4 <- tm_map(spam4,removeWords,stopwords("english"))
spam4 <- tm_map(spam4,stemDocument)

# creiamo la matrice documenti-termini
dtm <- as.data.frame.matrix(DocumentTermMatrix(spam4))

train <- dtm[1:300,]
test <- dtm[301:600,]

cl <- spam3[1:300,1]

install.packages("class")
library(class)

knn.pred <- knn(train, test, cl)

conf.mat <- table(knn.pred, cl)

(accuracy <- sum(diag(conf.mat))/length(test) * 100)


